## fp16 0.0~git20200514.4dfe081

=== CMakeLists.txt ===
CMAKE_MINIMUM_REQUIRED(VERSION 2.8.12 FATAL_ERROR)

INCLUDE(GNUInstallDirs)

# ---[ Project
PROJECT(FP16 C CXX)

# ---[ Options.
OPTION(FP16_BUILD_TESTS "Build FP16 unit tests" ON)
OPTION(FP16_BUILD_BENCHMARKS "Build FP16 micro-benchmarks" ON)

# ---[ CMake options
IF(FP16_BUILD_TESTS)
  ENABLE_TESTING()
ENDIF()

MACRO(FP16_TARGET_ENABLE_CXX11 target)
  IF(${CMAKE_VERSION} VERSION_LESS "3.1")
    IF(NOT MSVC)
      TARGET_COMPILE_OPTIONS(${target} PRIVATE -std=c++11)
    ENDIF()
  ELSE()
    SET_TARGET_PROPERTIES(${target} PROPERTIES
      CXX_STANDARD 11
      CXX_STANDARD_REQUIRED YES
      CXX_EXTENSIONS YES)
  ENDIF()
ENDMACRO()

# ---[ Download deps
SET(CONFU_DEPENDENCIES_SOURCE_DIR ${CMAKE_SOURCE_DIR}/deps
  CACHE PATH "Confu-style dependencies source directory")
SET(CONFU_DEPENDENCIES_BINARY_DIR ${CMAKE_BINARY_DIR}/deps
  CACHE PATH "Confu-style dependencies binary directory")

IF(NOT DEFINED PSIMD_SOURCE_DIR)
  MESSAGE(STATUS "Downloading PSimd to ${CONFU_DEPENDENCIES_SOURCE_DIR}/psimd (define PSIMD_SOURCE_DIR to avoid it)")
  CONFIGURE_FILE(cmake/DownloadPSimd.cmake "${CONFU_DEPENDENCIES_BINARY_DIR}/psimd-download/CMakeLists.txt")
  EXECUTE_PROCESS(COMMAND "${CMAKE_COMMAND}" -G "${CMAKE_GENERATOR}" .
    WORKING_DIRECTORY "${CONFU_DEPENDENCIES_BINARY_DIR}/psimd-download")
  EXECUTE_PROCESS(COMMAND "${CMAKE_COMMAND}" --build .
    WORKING_DIRECTORY "${CONFU_DEPENDENCIES_BINARY_DIR}/psimd-download")
  SET(PSIMD_SOURCE_DIR "${CONFU_DEPENDENCIES_SOURCE_DIR}/psimd" CACHE STRING "PSimd source directory")
ENDIF()

IF(FP16_BUILD_TESTS AND NOT DEFINED GOOGLETEST_SOURCE_DIR)
  MESSAGE(STATUS "Downloading Google Test to ${CONFU_DEPENDENCIES_SOURCE_DIR}/googletest (define GOOGLETEST_SOURCE_DIR to avoid it)")
  CONFIGURE_FILE(cmake/DownloadGoogleTest.cmake "${CONFU_DEPENDENCIES_BINARY_DIR}/googletest-download/CMakeLists.txt")
  EXECUTE_PROCESS(COMMAND "${CMAKE_COMMAND}" -G "${CMAKE_GENERATOR}" .
    WORKING_DIRECTORY "${CONFU_DEPENDENCIES_BINARY_DIR}/googletest-download")
  EXECUTE_PROCESS(COMMAND "${CMAKE_COMMAND}" --build .
    WORKING_DIRECTORY "${CONFU_DEPENDENCIES_BINARY_DIR}/googletest-download")
  SET(GOOGLETEST_SOURCE_DIR "${CONFU_DEPENDENCIES_SOURCE_DIR}/googletest" CACHE STRING "Google Test source directory")
ENDIF()

IF(FP16_BUILD_BENCHMARKS AND NOT DEFINED GOOGLEBENCHMARK_SOURCE_DIR)
  MESSAGE(STATUS "Downloading Google Benchmark to ${CONFU_DEPENDENCIES_SOURCE_DIR}/googlebenchmark (define GOOGLEBENCHMARK_SOURCE_DIR to avoid it)")
  CONFIGURE_FILE(cmake/DownloadGoogleBenchmark.cmake "${CONFU_DEPENDENCIES_BINARY_DIR}/googlebenchmark-download/CMakeLists.txt")
  EXECUTE_PROCESS(COMMAND "${CMAKE_COMMAND}" -G "${CMAKE_GENERATOR}" .
    WORKING_DIRECTORY "${CONFU_DEPENDENCIES_BINARY_DIR}/googlebenchmark-download")
  EXECUTE_PROCESS(COMMAND "${CMAKE_COMMAND}" --build .
    WORKING_DIRECTORY "${CONFU_DEPENDENCIES_BINARY_DIR}/googlebenchmark-download")
  SET(GOOGLEBENCHMARK_SOURCE_DIR "${CONFU_DEPENDENCIES_SOURCE_DIR}/googlebenchmark" CACHE STRING "Google Benchmark source directory")
ENDIF()

# ---[ FP16 library
IF(${CMAKE_VERSION} VERSION_LESS "3.0")
  ADD_LIBRARY(fp16 STATIC
    include/fp16.h
    include/fp16/fp16.h
    include/fp16/bitcasts.h
    include/fp16/psimd.h)
  SET_TARGET_PROPERTIES(fp16 PROPERTIES LINKER_LANGUAGE C)
ELSE()
  ADD_LIBRARY(fp16 INTERFACE)
ENDIF()
TARGET_INCLUDE_DIRECTORIES(fp16 INTERFACE
    $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>
    $<INSTALL_INTERFACE:include>)

INSTALL(FILES include/fp16.h
  DESTINATION ${CMAKE_INSTALL_INCLUDEDIR})
INSTALL(FILES
    include/fp16/bitcasts.h
    include/fp16/fp16.h
    include/fp16/psimd.h
    include/fp16/__init__.py
    include/fp16/avx.py
    include/fp16/avx2.py
  DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/fp16)

# ---[ Configure psimd
IF(NOT TARGET psimd)
  ADD_SUBDIRECTORY(
    "${PSIMD_SOURCE_DIR}"
    "${CONFU_DEPENDENCIES_BINARY_DIR}/psimd")
ENDIF()

IF(FP16_BUILD_TESTS)
  # ---[ Build google test
  IF(NOT TARGET gtest)
    SET(gtest_force_shared_crt ON CACHE BOOL "" FORCE)
    ADD_SUBDIRECTORY(
      "${GOOGLETEST_SOURCE_DIR}"
      "${CONFU_DEPENDENCIES_BINARY_DIR}/googletest")
  ENDIF()

  # ---[ Build FP16 unit tests
  ADD_EXECUTABLE(ieee-to-fp32-bits-test test/ieee-to-fp32-bits.cc test/tables.cc)
  TARGET_INCLUDE_DIRECTORIES(ieee-to-fp32-bits-test PRIVATE test)
  TARGET_LINK_LIBRARIES(ieee-to-fp32-bits-test fp16 gtest gtest_main)
  ADD_TEST(ieee-to-fp32-bits ieee-to-fp32-bits-test)

  ADD_EXECUTABLE(ieee-to-fp32-value-test test/ieee-to-fp32-value.cc test/tables.cc)
  TARGET_INCLUDE_DIRECTORIES(ieee-to-fp32-value-test PRIVATE test)
  TARGET_LINK_LIBRARIES(ieee-to-fp32-value-test fp16 gtest gtest_main)
  ADD_TEST(ieee-to-fp32-value ieee-to-fp32-value-test)

  ADD_EXECUTABLE(ieee-from-fp32-value-test test/ieee-from-fp32-value.cc test/tables.cc)
  TARGET_INCLUDE_DIRECTORIES(ieee-from-fp32-value-test PRIVATE test)
  TARGET_LINK_LIBRARIES(ieee-from-fp32-value-test fp16 gtest gtest_main)
  ADD_TEST(ieee-from-fp32-value ieee-from-fp32-value-test)

  ADD_EXECUTABLE(alt-to-fp32-bits-test test/alt-to-fp32-bits.cc test/tables.cc)
  TARGET_INCLUDE_DIRECTORIES(alt-to-fp32-bits-test PRIVATE test)
  TARGET_LINK_LIBRARIES(alt-to-fp32-bits-test fp16 gtest gtest_main)
  ADD_TEST(alt-to-fp32-bits alt-to-fp32-bits-test)

  ADD_EXECUTABLE(alt-to-fp32-value-test test/alt-to-fp32-value.cc test/tables.cc)
  TARGET_INCLUDE_DIRECTORIES(alt-to-fp32-value-test PRIVATE test)
  TARGET_LINK_LIBRARIES(alt-to-fp32-value-test fp16 gtest gtest_main)
  ADD_TEST(alt-to-fp32-value alt-to-fp32-value-test)

  ADD_EXECUTABLE(alt-from-fp32-value-test test/alt-from-fp32-value.cc test/tables.cc)
  TARGET_INCLUDE_DIRECTORIES(alt-from-fp32-value-test PRIVATE test)
  TARGET_LINK_LIBRARIES(alt-from-fp32-value-test fp16 gtest gtest_main)
  ADD_TEST(alt-from-fp32-value alt-from-fp32-value-test)

  ADD_EXECUTABLE(bitcasts-test test/bitcasts.cc)
  TARGET_LINK_LIBRARIES(bitcasts-test fp16 gtest gtest_main)
  ADD_TEST(bitcasts bitcasts-test)
ENDIF()

IF(FP16_BUILD_BENCHMARKS)
  # ---[ Build google benchmark
  IF(NOT TARGET benchmark)
    SET(BENCHMARK_ENABLE_TESTING OFF CACHE BOOL "")
    ADD_SUBDIRECTORY(
      "${GOOGLEBENCHMARK_SOURCE_DIR}"
      "${CONFU_DEPENDENCIES_BINARY_DIR}/googlebenchmark")
  ENDIF()

  # ---[ Build FP16 benchmarks
  ADD_EXECUTABLE(ieee-element-bench bench/ieee-element.cc)
  TARGET_COMPILE_DEFINITIONS(ieee-element-bench PRIVATE FP16_COMPARATIVE_BENCHMARKS=1)
  TARGET_INCLUDE_DIRECTORIES(ieee-element-bench PRIVATE ${PROJECT_SOURCE_DIR})
  TARGET_LINK_LIBRARIES(ieee-element-bench fp16 psimd benchmark)

  ADD_EXECUTABLE(alt-element-bench bench/alt-element.cc)
  TARGET_LINK_LIBRARIES(alt-element-bench fp16 psimd benchmark)

  ADD_EXECUTABLE(from-ieee-array-bench bench/from-ieee-array.cc)
  FP16_TARGET_ENABLE_CXX11(from-ieee-array-bench)
  TARGET_COMPILE_DEFINITIONS(from-ieee-array-bench PRIVATE FP16_COMPARATIVE_BENCHMARKS=1)
  TARGET_INCLUDE_DIRECTORIES(from-ieee-array-bench PRIVATE ${PROJECT_SOURCE_DIR})
  TARGET_LINK_LIBRARIES(from-ieee-array-bench fp16 psimd benchmark)

  ADD_EXECUTABLE(from-alt-array-bench bench/from-alt-array.cc)
  FP16_TARGET_ENABLE_CXX11(from-alt-array-bench)
  TARGET_LINK_LIBRARIES(from-alt-array-bench fp16 psimd benchmark)

  ADD_EXECUTABLE(to-ieee-array-bench bench/to-ieee-array.cc)
  FP16_TARGET_ENABLE_CXX11(to-ieee-array-bench)
  TARGET_COMPILE_DEFINITIONS(to-ieee-array-bench PRIVATE FP16_COMPARATIVE_BENCHMARKS=1)
  TARGET_INCLUDE_DIRECTORIES(to-ieee-array-bench PRIVATE ${PROJECT_SOURCE_DIR})
  TARGET_LINK_LIBRARIES(to-ieee-array-bench fp16 psimd benchmark)

  ADD_EXECUTABLE(to-alt-array-bench bench/to-alt-array.cc)
  FP16_TARGET_ENABLE_CXX11(to-alt-array-bench)
  TARGET_LINK_LIBRARIES(to-alt-array-bench fp16 psimd benchmark)
ENDIF()

## fp16 0.0~git20200412.3c54eac

=== debian/changelog ===
fp16 (0.0~git20200412.3c54eac-2.1) unstable; urgency=medium

  * Non-maintainer upload.
  * rebuild for mstrict-align

 -- root <root@loongson-pc>  Fri, 28 Jan 2022 12:30:42 +0800

fp16 (0.0~git20200412.3c54eac-2) unstable; urgency=medium

  * Add the missing Expat license. Thanks to FTP-Masters.
  * Apply wrap-and-sort.
  * Upload to unstable.

 -- Mo Zhou <lumin@debian.org>  Wed, 29 Apr 2020 08:07:34 +0800

fp16 (0.0~git20200412.3c54eac-1) experimental; urgency=medium

  * Initial release (Closes: #958650)

 -- Mo Zhou <lumin@debian.org>  Tue, 28 Apr 2020 11:55:44 +0800

=== debian/control ===
Source: fp16
Section: math
Homepage: https://github.com/Maratyszcza/FP16
Priority: optional
Standards-Version: 4.5.0
Vcs-Browser: https://salsa.debian.org/deeplearning-team/fp16
Vcs-Git: https://salsa.debian.org/deeplearning-team/fp16.git
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Felix Salfelder <felix@salfelder.org>, Mo Zhou <lumin@debian.org>
Build-Depends: cmake,
               debhelper-compat (= 12),
               googletest,
               libbenchmark-dev,
               libpsimd-dev
Rules-Requires-Root: no

Package: libfp16-dev
Architecture: any
Depends: ${misc:Depends}
Description: Conversion to/from half-precision floating point formats
 Header-only library for conversion to/from half-precision floating point
 formats Features
 .
  + Supports IEEE and ARM alternative half-precision floating-point format
    - Property converts infinities and NaNs
    - Properly converts denormal numbers, even on systems without denormal support
  + Header-only library, no installation or build required
  + Compatible with C99 and C++11
  + Fully covered with unit tests and microbenchmarks
 .
 This is a header-only library.

=== debian/rules ===
#!/usr/bin/make -f
%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- -DGOOGLETEST_SOURCE_DIR=/usr/src/googletest

override_dh_auto_test:
	dh_auto_test
	#-find . -type f -executable -name '*bench' -exec '{}' \;

override_dh_auto_install:
	dh_auto_install
	-$(RM) -rf debian/libfp16-dev/usr/lib
	-$(RM) -rf debian/libfp16-dev/usr/include/gmock
	-$(RM) -rf debian/libfp16-dev/usr/include/gtest
	-find debian/libfp16-dev -name '*.py' -delete

## fp16 0.0~git20200514.4dfe081

=== debian/changelog ===
fp16 (0.0~git20200514.4dfe081-5) unstable; urgency=medium

  * Team upload.

  [ Petter Reinholdtsen ]
  * Added ftbfs-gcc-14.patch to use required 'include <iomanip>' where needed.
    (Closes: #1077426)
  * Set upstream metadata fields: Bug-Database, Bug-Submit.

 -- Dylan Aïssi <daissi@debian.org>  Tue, 20 Aug 2024 17:47:04 +0200

fp16 (0.0~git20200514.4dfe081-4) unstable; urgency=medium

  [ Debian Janitor ]
  * Set upstream metadata fields: Repository-Browse.
  * Update standards version to 4.6.2, no changes needed.

  [ Mo Zhou ]
  * control: fix overlength description.

 -- Mo Zhou <lumin@debian.org>  Fri, 18 Aug 2023 14:15:14 -0400

fp16 (0.0~git20200514.4dfe081-3) unstable; urgency=medium

  * Fix i386 FTBFS with patch. (Closes: #996702)
  * d/copyright: Fix superfluous file pattern (lintian).

 -- Mo Zhou <lumin@debian.org>  Sun, 09 Jan 2022 12:20:10 -0500

fp16 (0.0~git20200514.4dfe081-2) unstable; urgency=medium

  * Change maintainer mail address to <debian-ai@l.d.o>.
  * Please pin to this upstream snapshot for PyTorch 1.7.0.

 -- Mo Zhou <lumin@debian.org>  Thu, 29 Oct 2020 13:31:11 +0800

fp16 (0.0~git20200514.4dfe081-1) unstable; urgency=medium

  * New upstream version 0.0~git20200514.4dfe081
  * Maintainer is Debian Deep Learning Team

 -- Mo Zhou <lumin@debian.org>  Mon, 31 Aug 2020 11:13:52 +0800

fp16 (0.0~git20200412.3c54eac-3) unstable; urgency=medium

  * Bump debhelper compat level to 13.
  * Don't remove the .py files from -dev package (required by rdepends).

 -- Mo Zhou <lumin@debian.org>  Thu, 30 Apr 2020 22:57:14 +0800

=== debian/control ===
Source: fp16
Section: math
Homepage: https://github.com/Maratyszcza/FP16
Priority: optional
Standards-Version: 4.6.2
Vcs-Browser: https://salsa.debian.org/deeplearning-team/fp16
Vcs-Git: https://salsa.debian.org/deeplearning-team/fp16.git
Maintainer: Debian Deep Learning Team <debian-ai@lists.debian.org>
Uploaders: Felix Salfelder <felix@salfelder.org>, Mo Zhou <lumin@debian.org>
Build-Depends: cmake,
               debhelper-compat (= 13),
               googletest,
               libbenchmark-dev,
               libpsimd-dev
Rules-Requires-Root: no

Package: libfp16-dev
Architecture: any
Depends: ${misc:Depends}
Description: Conversion to/from half-precision floating point formats
 Header-only library for conversion to/from half-precision floating point
 formats Features
 .
  + Supports IEEE and ARM alternative half-precision floating-point format
    - Property converts infinities and NaNs
    - Properly converts denormal numbers
  + Header-only library, no installation or build required
  + Compatible with C99 and C++11
  + Fully covered with unit tests and microbenchmarks
 .
 This is a header-only library.

=== debian/watch ===
version=4
opts="mode=git, pgpmode=none" \
https://github.com/Maratyszcza/FP16 \
HEAD debian uupdate
